//HEADER
#include <string.h>

//SLICE
void* memcpy(void * restrict dst, const void * restrict src, size_t n) {
	for (size_t i=0; i<n; ++i) ((char*)dst)[i] = ((const char*)src)[i];

	return dst;
}

//SLICE
void* memmove(void *dst, const void *src, size_t n) {
	if ((unsigned)dst<(unsigned)src) for (size_t i=0; i<n; ++i) ((char*)dst)[i] = ((const char*)src)[i];
	else for (size_t i=0; i<n; ++i) ((char*)dst)[n-1-i] = ((const char*)src)[n-1-i];

	return dst;
}

//SLICE
void* memset(void *dst, int c, size_t n) {
	for (int i=0; i<n; ++i) ((char*)dst)[i] = c;

	return dst;
}

//SLICE
int memcmp(const void *s1, const void *s2, size_t n) {
	for (int i=0; i<n; ++i) {
		int diff = ((const char*)s1)[i] - ((const char*)s2)[i];
		if (diff!=0) return diff;
	}
	return 0;
}

//SLICE
size_t strlen(const char *s) {
	size_t length = 0;
	while (*s++) length++;
	return length;
}

//SLICE
const char* strchr(const char *str, char c) {
	for ( ; *str ; ++str) if (*str==c) return str;
	return 0;
}

