/*
  lpc8/syscon.h 
  Copyright 2013 Marc Prager
 
  This file is part of the c-lpc8 library.
  c-lpc8 is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.
 
  c-lpc8 is published in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License along with c-lpc8.
  If not see <http://www.gnu.org/licenses/>
 */

#ifndef lpc8__syscon_h
#define lpc8__syscon_h

#include <integers.h>
#include <unionized.h>

union PACKED4 Syscon {
	//.0x000
	unionized struct PACKED { char _0[0x000]; // padding
	volatile Uint32		memRemap;
	unionized };
	//.0x004
	unionized struct PACKED { char _1[0x004]; // padding
	volatile Uint32		pResetCtrl;
	unionized };
	//.0x008
	unionized struct PACKED { char _2[0x008]; // padding
	volatile Uint32		pllCtrl;
	unionized };
	//.0x00C
	unionized struct PACKED { char _3[0x00C]; // padding
	volatile Uint32		pllStat;
	unionized };
	//.0x020
	unionized struct PACKED { char _4[0x020]; // padding
	volatile Uint32		oscCtrl;
	unionized };
	//.0x024
	unionized struct PACKED { char _5[0x024]; // padding
	volatile Uint32		wdOscCtrl;
	unionized };
	//.0x030
	unionized struct PACKED { char _6[0x030]; // padding
	volatile Uint32		rstStat;
	unionized };
	//.0x040
	unionized struct PACKED { char _7[0x040]; // padding
	volatile Uint32		pllClkSel;
	unionized };
	//.0x044
	unionized struct PACKED { char _8[0x044]; // padding
	volatile Uint32		pllClkUen;
	unionized };
	//.0x070
	unionized struct PACKED { char _9[0x070]; // padding
	volatile Uint32		mainClkSel;
	unionized };
	//.0x074
	unionized struct PACKED { char _10[0x074]; // padding
	volatile Uint32		mainClkUen;
	unionized };
	//.0x078
	unionized struct PACKED { char _11[0x078]; // padding
	volatile Uint32		ahbClkDiv;
	unionized };
	//.0x080
	unionized struct PACKED { char _12[0x080]; // padding
	volatile Uint32		ahbClkCtrl;
	unionized };
	//.0x094
	unionized struct PACKED { char _13[0x094]; // padding
	volatile Uint32		usartClkDiv;
	unionized };
	//.0x0E0
	unionized struct PACKED { char _14[0x0E0]; // padding
	volatile Uint32		clkOutSel;
	unionized };
	//.0x0E4
	unionized struct PACKED { char _15[0x0E4]; // padding
	volatile Uint32		clkOutUen;
	unionized };
	//.0x0E8
	unionized struct PACKED { char _16[0x0E8]; // padding
	volatile Uint32		clkOutDiv;
	unionized };
	//.0x0F0
	unionized struct PACKED { char _17[0x0F0]; // padding
	volatile Uint32		usartFrgDiv;
	unionized };
	//.0x0F4
	unionized struct PACKED { char _18[0x0F4]; // padding
	volatile Uint32		usartFrgMul;
	unionized };
	//.0xFC
	unionized struct PACKED { char _19[0xFC]; // padding
	volatile Uint32		extTraceCmd;
	unionized };
	//.0x100
	unionized struct PACKED { char _20[0x100]; // padding
	volatile Uint32		pioPorCap0;
	unionized };
	//.0x134
	unionized struct PACKED { char _21[0x134]; // padding
	volatile Uint32		ioconClkDiv6;
	unionized };
	//.0x138
	unionized struct PACKED { char _22[0x138]; // padding
	volatile Uint32		ioconClkDiv5;
	unionized };
	//.0x13C
	unionized struct PACKED { char _23[0x13C]; // padding
	volatile Uint32		ioconClkDiv4;
	unionized };
	//.0x140
	unionized struct PACKED { char _24[0x140]; // padding
	volatile Uint32		ioconClkDiv3;
	unionized };
	//.0x144
	unionized struct PACKED { char _25[0x144]; // padding
	volatile Uint32		ioconClkDiv2;
	unionized };
	//.0x148
	unionized struct PACKED { char _26[0x148]; // padding
	volatile Uint32		ioconClkDiv1;
	unionized };
	//.0x14C
	unionized struct PACKED { char _27[0x14C]; // padding
	volatile Uint32		ioconClkDiv0;
	unionized };
	//.0x150
	unionized struct PACKED { char _28[0x150]; // padding
	volatile Uint32		bodCtrl;
	unionized };
	//.0x154
	unionized struct PACKED { char _29[0x154]; // padding
	volatile Uint32		sysTckCal;
	unionized };
	//.0x170
	unionized struct PACKED { char _30[0x170]; // padding
	volatile Uint32		irqLatency;
	unionized };
	//.0x174
	unionized struct PACKED { char _31[0x174]; // padding
	volatile Uint32		nmiSrc;
	unionized };
	//.0x178
	unionized struct PACKED { char _32[0x178]; // padding
	volatile Uint32		pIntSel[8];
	unionized };
	//.0x204
	unionized struct PACKED { char _33[0x204]; // padding
	volatile Uint32		starterP0;
	unionized };
	//.0x214
	unionized struct PACKED { char _34[0x214]; // padding
	volatile Uint32		starterP1;
	unionized };
	//.0x230
	unionized struct PACKED { char _35[0x230]; // padding
	volatile Uint32		pdSleepCfg;
	unionized };
	//.0x234
	unionized struct PACKED { char _36[0x234]; // padding
	volatile Uint32		pdAwakeCfg;
	unionized };
	//.0x238
	unionized struct PACKED { char _37[0x238]; // padding
	volatile Uint32		pdRunCfg;
	unionized };
	//.0x3F8
	unionized struct PACKED { char _38[0x3F8]; // padding
	volatile Uint32		deviceId;
	unionized };
};

extern union Syscon SYSCON;		///< defined in crt0

enum SysconPResetCtrlBits {
	_SYSCON_PRESETCTRL_SPI0		=0,	///< 0=reset; 1=deassert reset, enable
	_SYSCON_PRESETCTRL_SPI1		=1,	///< 0=reset; 1=deassert reset, enable
	_SYSCON_PRESETCTRL_UARTFRG	=2,	///< 0=reset; 1=deassert reset, enable
	_SYSCON_PRESETCTRL_USART0	=3,	///< 0=reset; 1=deassert reset, enable
	_SYSCON_PRESETCTRL_USART1	=4,	///< 0=reset; 1=deassert reset, enable
	_SYSCON_PRESETCTRL_USART2	=5,	///< 0=reset; 1=deassert reset, enable
	_SYSCON_PRESETCTRL_I2C		=6,	///< 0=reset; 1=deassert reset, enable
	_SYSCON_PRESETCTRL_MRT		=7,	///< 0=reset; 1=deassert reset, enable
	_SYSCON_PRESETCTRL_SCT		=8,	///< 0=reset; 1=deassert reset, enable
	_SYSCON_PRESETCTRL_WKT		=9,	///< 0=reset; 1=deassert reset, enable
	_SYSCON_PRESETCTRL_GPIO		=10,	///< 0=reset; 1=deassert reset, enable
	_SYSCON_PRESETCTRL_FLASH	=11,	///< 0=reset; 1=deassert reset, enable
	_SYSCON_PRESETCTRL_ACMP		=12,	///< 0=reset; 1=deassert reset, enable
	SYSCON_PRESETCTRL_DEASSERT_ALL	= 0x1FFF,
};

enum SysconMainclkSelBits {
	SYSCON_MAINCLKSEL_IRC		=0,
	SYSCON_MAINCLKSEL_PLLIN		=1,
	SYSCON_MAINCLKSEL_WDOSC		=2,
	SYSCON_MAINCLKSEL_PLLOUT	=3,
};

enum SysconClkoutSelBits {
	SYSCON_CLKOUTSEL_IRC		=0,
	SYSCON_CLKOUTSEL_CRYSTAL	=1,
	SYSCON_CLKOUTSEL_WDOSC		=2,
	SYSCON_CLKOUTSEL_MAINCLK	=3,	///< before AHB clock divider
};

enum SysconAhbClkCtrlBits {
	_SYSCON_AHBCLKCTRL_SYS		=0,	///< read only (as 1): AHB,APB,core,SYSCON clocks
	_SYSCON_AHBCLKCTRL_ROM		=1,	///< ROM clock
	_SYSCON_AHBCLKCTRL_RAM		=2,	///< SRAM clock
	_SYSCON_AHBCLKCTRL_FLASHREG	=3,	///< flash register interface
	_SYSCON_AHBCLKCTRL_FLASH	=4,	///< flash memory
	_SYSCON_AHBCLKCTRL_I2C		=5,	///< I2C clock
	_SYSCON_AHBCLKCTRL_GPIO		=6,	///< port pins and pin interrupt clock
	_SYSCON_AHBCLKCTRL_SWM		=7,	///< switch matrix (needed for configuring, only)
	_SYSCON_AHBCLKCTRL_SCT		=8,	///< state configurable timer
	_SYSCON_AHBCLKCTRL_WKT		=9,
	_SYSCON_AHBCLKCTRL_MRT		=10,
	_SYSCON_AHBCLKCTRL_SPI0		=11,
	_SYSCON_AHBCLKCTRL_SPI1		=12,
	_SYSCON_AHBCLKCTRL_CRC		=13,
	_SYSCON_AHBCLKCTRL_USART0	=14,
	_SYSCON_AHBCLKCTRL_USART1	=15,
	_SYSCON_AHBCLKCTRL_USART2	=16,
	_SYSCON_AHBCLKCTRL_WWDT		=17,
	_SYSCON_AHBCLKCTRL_IOCON	=18,
	_SYSCON_AHBCLKCTRL_ACMP		=19,
	SYSCON_AHBCLKCTRL_RESET_DEFAULT	= 1<<_SYSCON_AHBCLKCTRL_SYS
					| 1<<_SYSCON_AHBCLKCTRL_ROM
					| 1<<_SYSCON_AHBCLKCTRL_RAM
					| 1<<_SYSCON_AHBCLKCTRL_FLASHREG
					| 1<<_SYSCON_AHBCLKCTRL_FLASH
					,
};

enum SysconPdRunCfgBits {
	_SYSCON_PDRUNCFG_IRCOUT	=0,
	_SYSCON_PDRUNCFG_IRC	=1,
	_SYSCON_PDRUNCFG_FLASH	=2,
	_SYSCON_PDRUNCFG_BOD	=3,
	_SYSCON_PDRUNCFG_0x01	=4,	///< reserved, write als 0x01
	_SYSCON_PDRUNCFG_SYSOSC	=5,
	_SYSCON_PDRUNCFG_WDOSC	=6,
	_SYSCON_PDRUNCFG_SYSPLL	=7,
	_SYSCON_PDRUNCFG_0x6D	=8,	///< 7 bits, always write as 0x6D
	_SYSCON_PDRUNCFG_ACMP	=15,
};

enum SysconWdtoscctrlBits {
	_SYSCON_WDOSCCTRL_DIVSEL	=0,	///< 5 bits: divider=2 * (DIVSEL+1)
	_SYSCON_WDOSCCTRL_FREQSEL	=5,	///< 4 bits: analog frequency selection
		SYSCON_WDOSCCTRL_FREQSEL_0_6MHZ_	=1,
		SYSCON_WDOSCCTRL_FREQSEL_1_05MHZ_	=2,
		SYSCON_WDOSCCTRL_FREQSEL_1_4MHZ_	=3,
		SYSCON_WDOSCCTRL_FREQSEL_1_75MHZ_	=4,
		SYSCON_WDOSCCTRL_FREQSEL_2_1MHZ_	=5,
		SYSCON_WDOSCCTRL_FREQSEL_2_4MHZ_	=6,
		SYSCON_WDOSCCTRL_FREQSEL_2_7MHZ_	=7,
		SYSCON_WDOSCCTRL_FREQSEL_3_0MHZ_	=8,
		SYSCON_WDOSCCTRL_FREQSEL_3_25MHZ_	=9,
		SYSCON_WDOSCCTRL_FREQSEL_3_5MHZ_	=10,
		SYSCON_WDOSCCTRL_FREQSEL_3_75MHZ_	=11,
		SYSCON_WDOSCCTRL_FREQSEL_4_0MHZ_	=12,
		SYSCON_WDOSCCTRL_FREQSEL_4_2MHZ_	=13,
		SYSCON_WDOSCCTRL_FREQSEL_4_4MHZ_	=14,
		SYSCON_WDOSCCTRL_FREQSEL_4_6MHZ_	=15,
};

enum SysconStarterP1Bits {
	_SYSCON_STARTERP1_SPI0		=0,
	_SYSCON_STARTERP1_SPI1		=1,

	_SYSCON_STARTERP1_USART0	=3,
	_SYSCON_STARTERP1_USART1	=4,
	_SYSCON_STARTERP1_USART2	=5,

	_SYSCON_STARTERP1_I2C		=8,

	_SYSCON_STARTERP1_WWDT		=12,
	_SYSCON_STARTERP1_BOD		=13,

	_SYSCON_STARTERP1_WKT		=15,
};

#endif

