/* Linker script for small assembler executables in FLASH for LPC8xx devices.
 * Startup code omitted.
 *(C) Marc Prager, 2013
 */

OUTPUT_FORMAT("elf32-littlearm")
OUTPUT_ARCH(arm)
ENTRY(_start)

MEMORY {
	ram (w)		: ORIGIN = 0x10000000, LENGTH = 4K
}

SECTIONS
{
	.text 		: {
			__text_start = . ;
			*(.text.vectorTable)
			*(.text)
			__text_end = . ;
	} > ram = 0x0000



	.rodata 	: {
			__rodata_start = . ;
			*(.rodata*)
			__rodata_end = . ;
			__data_romimage = . ;
	} > ram = 0x0000


	
	.data : {
			__data_start = . ;
			*(.data)
			__data_end = . ;
	} > ram = 0x0000 



	.bss		: {
			__bss_start = . ;
			*(.bss) *(COMMON)
			__bss_end = . ;
	} > ram = 0x0000
}

